; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Project name : C++ Class Interface Demonstration
; File Name : C++ Class Interface Demonstration.pb
; File version: 2.0.0
; Programming : OK
; Programmed by : StarBootics
; Date : 01-10-2016
; Last Update : 04-10-2016
; PureBasic code : V5.50
; Platform : Linux x64
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
;
; In this example we will create a Module to drive
; a C++ Class Interface directly from a *.so 
; library.
;
; This code is free to be use where ever you like 
; but you use it at your own risk.
;
; The author can in no way be held responsible 
; for data loss, damage or other annoying 
; situations that may occur.
;
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule TimeDate
  
  Declare Initialize()
  
  Declare SetHour(Hour.l)
  Declare SetMinute(Minute.l)
  Declare SetSecond(Second.l)
  Declare SetDay(Day.l)
  Declare SetMonth(Month.l)
  Declare SetYear(Year.l)

  Declare.l GetHour()
  Declare.l GetMinute()
  Declare.l GetSecond()
  Declare.l GetDay()
  Declare.l GetMonth()
  Declare.l GetYear()
  
  Declare Update(Hour.l, Minute.l, Second.l, Day.l, Month.l, Year.l)
  Declare Refresh()
  
  Declare Reset()
  Declare.s Format()
  
  CompilerIf #PB_Compiler_Debugger
    Declare Debugging()
  CompilerEndIf
  
EndDeclareModule

Module TimeDate
  
  Interface Time
    
    Update(Hour.l, Minute.l, Second.l)
    SetHour(Hour.l)
    SetMinute(Minute.l)
    SetSecond(Second.l)
    GetHour.l()
    GetMinute.l()
    GetSecond.l()
    Refresh()
    
  EndInterface
  
  
  Interface Date
    
    Update(day.l, month.l, year.l)
    SetDay(day.l)
    SetMonth(month.l)
    SetYear(year.l)
    GetDay.l()
    GetMonth.l()
    GetYear.l()
    Refresh()
    
  EndInterface
  
  
  
  
  ImportC "source/bin/Release/libtime.so"
    
    NewTime() As "CreateTimeInterface"
    DeleteTime.l(*Ptr) As "DeleteTimeInterface"
    NewDate() As "CreateDateInterface"
    DeleteDate.l(*Ptr) As "DeleteDateInterface"

  EndImport 
  
  Global Time.Time
  Global Date.Date
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Initialize Operator <<<<<
  
  Procedure Initialize()
    
    Time = NewTime()
    Date = NewDate()
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Observator <<<<<
  
  Procedure.l GetHour()
    
    ProcedureReturn Time\GetHour()
  EndProcedure
  
  Procedure.l GetMinute()
    
    ProcedureReturn Time\GetMinute()
  EndProcedure
  
  Procedure.l GetSecond()
    
    ProcedureReturn Time\GetSecond()
  EndProcedure
  
  Procedure.l GetDay()
    
    ProcedureReturn Date\GetDay()
  EndProcedure
  
  Procedure.l GetMonth()
    
    ProcedureReturn Date\GetMonth()
  EndProcedure
  
  Procedure.l GetYear()
    
    ProcedureReturn Date\GetYear()
  EndProcedure
 
  ; <<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Mutator <<<<<
  
  Procedure SetHour(Hour.l)
    
    Time\SetHour(Hour)
    
  EndProcedure
  
  Procedure SetMinute(Minute.l)
    
    Time\SetMinute(Minute)
    
  EndProcedure
  
  Procedure SetSecond(Second.l)
    
    Time\SetSecond(Second)
    
  EndProcedure
  
  Procedure SetDay(Day.l)
    
    Date\SetDay(Day)
    
  EndProcedure
  
  Procedure SetMonth(Month.l)
    
    Date\SetMonth(Month)
    
  EndProcedure
  
  Procedure SetYear(Year.l)
    
    Date\SetYear(Year)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Update Operator <<<<<
  
  Procedure Update(Hour.l, Minute.l, Second.l, Day.l, Month.l, Year.l)
   
    Time\Update(Hour, Minute, Second)
    Date\Update(Day, Month, Year)
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Refresh Operator <<<<<
  
  Procedure Refresh()
    
    Time\Refresh()
    Date\Refresh()
    
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Reset Operator <<<<<
  
  Procedure Reset()
    
    ; Here we will make sure that our created
    ; Time and Date Object is no longer valid !
    
    Time = DeleteTime(Time)
    Date = DeleteDate(Date)
    
  EndProcedure
 
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Nom de la procdure <<<<<
  
  Procedure.s Format()
    
    Part00.s = RSet(Str(Time\GetHour()), 2, "0") + ":" + RSet(Str(Time\GetMinute()), 2, "0") + ":" + RSet(Str(Time\GetSecond()), 2, "0")
    
    Part01.s = RSet(Str(Date\GetDay()), 2, "0") + "-" + RSet(Str(Date\GetMonth()), 2, "0") + "-" + RSet(Str(Date\GetYear()), 4, "0")
    
    ProcedureReturn Part00 + " " + Part01
  EndProcedure
  
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< The Debogging operator <<<<<
  
  CompilerIf #PB_Compiler_Debugger
    
    Procedure Debugging()
      
      If Time And Date
        
        Debug Time\GetHour()
        Debug Time\GetMinute()
        Debug Time\GetSecond()
        Debug Date\GetDay()
        Debug Date\GetMonth()
        Debug Date\GetYear()
        
      Else
        Debug "The Time Object is invalid !"
      EndIf
      
    EndProcedure
    
  CompilerEndIf
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  TimeDate::Initialize()
  
  TimeDate::Update(21, 06, 30, 04, 10, 2016)
  
  Debug TimeDate::Format()
  
  
  TimeDate::SetHour(23)
  TimeDate::SetMinute(52)
  TimeDate::SetSecond(45)
  
  Debug TimeDate::Format()
  
  TimeDate::Refresh()
  
  Debug TimeDate::Format()
  
  
  
  
  
  TimeDate::Reset()
  
  CompilerIf #PB_Compiler_Debugger
    TimeDate::Debugging()
  CompilerEndIf
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<
; <<<<< END OF FILE <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.50 (Linux - x64)
; Folding = -----
; EnableXP
; CompileSourceDirectory